
import java.util.*;

// History of moves on a board, and logic to determine when a move is completed.
// In this implementation that logic is based on time, not on correct moves.
class ttchess_history {

	Vector history = new Vector();  // Completed moves
	ttchess_snapshot lastadded = null;  // The last full move added to history
	ttchess_snapshot last = null;  // The last move, a move we're not sure is completed yet
	ttchess_chessboard board;  // The board that this history belongs to

	public ttchess_history(ttchess_chessboard _board) {
		board = _board;
	}

	void append(ttchess_snapshot x) {
		System.out.println("Append size: " + history.size() );
		if(history.size()==0){
			history.addElement(x.copy());
			board.update_html();
		}
		else if(x.sameas((ttchess_snapshot)history.lastElement())==false ){
			System.out.println("Not same");
			history.addElement(x.copy());
			board.update_html();
		}
		else
			System.out.println("Same board as last.");

	}

	// my little experiment...
	void _experiment_append(ttchess_snapshot x) {

		if (last==null) {
			if (lastadded==null) last = x.copy();  // This is the very first move.
			else if (lastadded.sameas(x)==false) {
				// This is the first move after a timeout, and something has changed
				last = x.copy();  // something new
			}
		}
		else if ((x.time.getTime() - last.time.getTime()) < 2000) { // milliseconds
			// this is happening to soon after the last move, so the last move
			// was probably not a completed move. Skip the last move.
			last = x.copy();
		}
		else { // More than 2 seconds has passed.
			if (lastadded!=null) {
				if (lastadded.sameas(x)) return;  // nothing new
			}
			// save the last move and consider the current snapshot as a move
			history.addElement(last);
			lastadded = last;
			last = x.copy();
			board.update_html();
//			debugprint();
		}
	}

	void debugprint() {
		System.out.println("======= History for board: "+board.address.toString());
		for (Enumeration e = history.elements(); e.hasMoreElements() ;) {
			((ttchess_snapshot)(e.nextElement())).debugprint();
		}
	}
}
