
import java.util.*;

// A view of a board, and the time of that view.
class ttchess_snapshot extends ttchess_common {

	int[] pieces = new int[64];
	Date time;
	ttchess_chessboard board;

	// An empty board
	public ttchess_snapshot(ttchess_chessboard _board) {
		time = new Date();
		board = _board;
		set_emptyboard();
	}

	// Copy another board, this is used for snapshots to store in the history
	public ttchess_snapshot(ttchess_snapshot x) {
		for (int i=0; i<64; i=i+1) pieces[i] = x.pieces[i];
		time = x.time;
		board = x.board;
	}

	ttchess_snapshot copy() {
		return new ttchess_snapshot(this);
	}

	// Returns true if the snapshots are equal
	public boolean sameas(ttchess_snapshot x) {
		for (int i=0; i<64; i=i+1) if (pieces[i] != x.pieces[i]) return false;
		return true;
	}

	
	Date get_time() { return time; }

	void set_emptyboard() {
		time = new Date();
		for (int i=0; i<64; i=i+1) pieces[i]=EMPTY;
	}

	// Sets all 64 fields
	void set_boarddump(int[] all64, int startpos) {
		time = new Date();
		for (int i=0; i<64; i=i+1) {
			int p = all64[i+startpos];
			if (is_piece(p)==false) {
				System.out.println("Confused: Boarddump contained an unknown piece");
				pieces[i]=EMPTY;
			} else {
				pieces[i]=p;
			}
		}
	}

	// Sets one field
	void set_fieldupdate(int piece, int pos) {
		time = new Date();
		if (pos <0 || pos > 63) {
			System.out.println("Confused: Fieldupdate for pos outside 0..63");
			return;
		}
		if (is_piece(piece)==false) {
			System.out.println("Confused: Fieldupdate with an unknown piece");
			return;
		}
		pieces[pos]=piece;
	}

	void debugprint() {
		StringBuffer s = new StringBuffer(300);
		for (int i=0; i<8; i=i+1) {
			for (int j=0; j<8; j=j+1) {
				int p = pieces[(i*8)+j];
				if (p==EMPTY  ) s.append(".");
				if (p==WPAWN  ) s.append("P");
				if (p==WROOK  ) s.append("R");
				if (p==WKNIGHT) s.append("N");
				if (p==WBISHOP) s.append("B");
				if (p==WKING  ) s.append("K");
				if (p==WQUEEN ) s.append("Q");
				if (p==BPAWN  ) s.append("p");
				if (p==BROOK  ) s.append("r");
				if (p==BKNIGHT) s.append("n");
				if (p==BBISHOP) s.append("b");
				if (p==BKING  ) s.append("k");
				if (p==BQUEEN ) s.append("q");
			}
			s.append("\n");
		}
		System.out.println(s);
	}
}
